VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cFormWizard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'************************************************************
'* Written by Thomas Coombs, November 2000.                 *
'*                                                          *
'* This is my first class so if you can improve it,         *
'* please do.  But... if you do, please mail me the new     *
'* version.  mail@thomascoombs.co.uk                        *
'*                                                          *
'* To use, just specify the required parameters. The label  *
'* is used to refresh the form, the remaining optional      *
'* parameters are used for positioning.                     *
'*                                                          *
'* Example.  Grows The Form center screen.                  *
'* Dim ShowForm As cFormWizard                              *
'* Set ShowForm = New cFormWizard                           *
'* ShowForm.GrowThatForm Form1, Form1.Width, Form1.Height, _*
'* Form1.lblNetScore, , , True                              *
'* Set ShowForm = Nothing                                   *
'*                                                          *
'* Known Problems.                                          *
'* 1.  If the forms border style is 0 (none) then the form  *
'*     will not close properly.                             *
'************************************************************
Option Explicit

Public Function GrowThatForm(frmName As Form, _
                            ByVal frmWidth As Integer, _
                            ByVal frmHeight As Integer, _
                            ByVal lblName As Label, _
                            Optional frmTop As Integer, _
                            Optional frmLeft As Integer, _
                            Optional FrmCentre As Boolean)
Dim hInc As Integer, wInc As Integer, Speed As Integer
Dim GrowSteps As Integer

Dim hIncMod As Integer, wIncMod As Integer
hInc = 0: wInc = 0: Speed = 150: hIncMod = 0: wIncMod = 0

'Check if form needs positioning and position
If frmTop > 0 Then
    frmName.Top = frmTop
End If

If frmLeft > 0 Then
    frmName.Left = frmLeft
End If

If FrmCentre = True Then
    frmName.Top = (Screen.Height - frmHeight) / 2
    frmName.Left = (Screen.Width - frmWidth) / 2
End If

'Set Width and Height to 0 or reduce it as much as possible
frmName.Width = 0
frmName.Height = 0

'Calculate Width and Height Values.  Adjust if form width/height is not 0
    wInc = (frmWidth - frmName.Width) / Speed
    wIncMod = (frmWidth - frmName.Width) Mod Speed
    hInc = (frmHeight - frmName.Height) / Speed
    hIncMod = (frmHeight - frmName.Height) Mod Speed

'Show form
frmName.Show

'Grow The form
For GrowSteps = 1 To Speed
    If GrowSteps < hIncMod Then 'Add 1 to accomodate any excess
        frmName.Height = frmName.Height + (hInc + 1)
    Else
        frmName.Height = frmName.Height + hInc
    End If
    If GrowSteps < wIncMod Then 'Add 1 to accomodate any excess
        frmName.Width = frmName.Width + (wInc + 1)
    Else
        frmName.Width = frmName.Width + wInc
    End If
    lblName.Refresh
Next
frmName.Height = frmHeight
frmName.Width = frmWidth
End Function

Public Function ShrinkThatForm(frmName As Form, _
                            ByVal frmWidth As Long, _
                            ByVal frmHeight As Long, _
                           lblName As Label)
Dim hInc As Integer, wInc As Integer, Speed As Integer
Dim GrowSteps As Integer

Dim hIncMod As Integer, wIncMod As Integer
hInc = 0: wInc = 0: Speed = 150: hIncMod = 0: wIncMod = 0


'Calculate Width and Height Values
    wInc = (frmWidth - frmName.Width) / Speed
    wIncMod = (frmWidth - frmName.Width) Mod Speed
    hInc = (frmHeight - frmName.Height) / Speed
    hIncMod = (frmHeight - frmName.Height) Mod Speed

'Grow The form
For GrowSteps = 1 To Speed
    If GrowSteps < hIncMod Then 'Add 1 to accomodate any excess
        frmName.Height = frmName.Height - (hInc + 1)
    Else
        frmName.Height = frmName.Height - hInc
    End If
    If GrowSteps < wIncMod Then 'Add 1 to accomodate any excess
        frmName.Width = frmName.Width - (wInc + 1)
    Else
        frmName.Width = frmName.Width - wInc
    End If
    lblName.Refresh
Next
Unload frmName
End Function

Public Function RollDownThatForm(frmName As Form, _
                            ByVal frmHeight As Integer, _
                            ByVal lblName As Label, _
                            Optional frmTop As Integer, _
                            Optional frmLeft As Integer, _
                            Optional FrmCentre As Boolean)
Dim hInc As Integer, Speed As Integer, hIncMod As Integer
Dim GrowSteps As Integer

hInc = 0: hIncMod = 0: Speed = 2000


'Check if form needs positioning
If frmTop > 0 Then
    frmName.Top = frmTop
End If

If frmLeft > 0 Then
    frmName.Left = frmLeft
End If

If FrmCentre = True Then
    frmName.Top = (Screen.Height - frmHeight) / 2
    frmName.Left = (Screen.Width - frmName.Width) / 2
End If

'Set Width and Height to 0 or reduce it as much as possible
frmName.Height = 0

'Calculate Width and Height Values
    hInc = Int((frmHeight - frmName.Height) / Speed)
    hIncMod = (frmHeight - frmName.Height) Mod Speed

'Show form
frmName.Show

'Grow The form
For GrowSteps = 1 To Speed
    If GrowSteps < hIncMod Then 'Add 1 to accomodate any excess
        frmName.Height = frmName.Height + (hInc + 1)
    Else
        frmName.Height = frmName.Height + hInc
    End If
    lblName.Refresh
Next
frmName.Height = frmHeight
End Function

Public Function RollUpThatForm(frmName As Form, _
                            ByVal frmHeight As Integer, _
                            ByVal lblName As Label)
Dim hInc As Integer, Speed As Integer, hIncMod As Integer
Dim GrowSteps As Long
hInc = 0: hIncMod = 0: Speed = 2000
'Calculate Width and Height Values
    hInc = Int((frmHeight - frmName.Height) / Speed)
    hIncMod = (frmHeight - frmName.Height) Mod Speed

'Show form
frmName.Show

'Grow The form
For GrowSteps = 1 To Speed
    If GrowSteps < hIncMod Then 'Add 1 to accomodate any excess
        frmName.Height = frmName.Height - (hInc + 1)
    Else
        frmName.Height = frmName.Height - hInc
    End If
    lblName.Refresh
Next
Unload frmName
End Function

